<html><head><title>WebSocket</title>
<style type="text/css">
html,body {
	font:normal 0.9em arial,helvetica;
}
#log {
	width:600px;
	height:300px;
	border:1px solid #7F9DB9;
	overflow:auto;
}
#msg {
	width:200px;
}
</style>
<script type="text/javascript" src="/socketcluster.js"></script>
<script>

function makeid(num)
{
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for( var i=0; i < num; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}

function getCookies() {
    var cookies = document.cookie.split( ';' );
    var list = {} ;
    for ( i = 0; i < cookies.length; i++ ) {
        var cv = cookies[i].split( '=' );
        var name = cv[0].replace(/\s+/g, "").replace(/\s+$/g,"") ;
        list[name] =  cv[1] ;
    }
   return (list) ;
}

// get cookies
cookies = getCookies();

// may want to use some kind of authentication stored in cookies
/*
// If we don't already have an IDtoken tracking generate one
if(cookies["IDtoken"] == undefined)
{
	IDtoken = makeid(20);
	document.cookie = "IDtoken="+IDtoken+"; expires=Wed, 01 Jan 2020 00:00:00 UTC";
}
else IDtoken = cookies["IDtoken"];

// Recover any existing datalisten channel
if(cookies["datalisten"] == undefined )
{
	datalisten = makeid(10);
	document.cookie = "datalisten="+datalisten;
}
else datalisten = cookies["datalisten"];
*/

// Initiate the connection to the server
var socket = socketCluster.connect({query: {client: "wallboard"}});

// Display errors
socket.on('error', function (err) {
	throw 'Socket error - ' + err;
});

// On a successful connection
socket.on('connect', function () {
	console.log('Server Channel Connected');
	 $("status").innerHTML = '<font color="green">Online</font>';
});


// we want to start a data channel that we listen on
var dataChannel = socket.subscribe("wallboard");
console.log('Listening on data channel');

// Listen to events and messages direct from remote party
dataChannel.watch(function (data) {
	console.log(data);
	switch(data.type)
	{
	case "videochat":
  break;

  case "voicechat":
  break;

  case "textchat":
    insertrow(data.websocket, data.type, data.datachannel, data.priority, data.status, data.timestamp, data.url, data.position)
  break;

  case "update":
    updaterow(data.websocket, data.status, data.position, data.connectedto, data.answertype)
  break;

  case "cancel":
    cancelrow(data.websocket)
  break;

	default:
		console.log("unknown message on data channel "+JSON.stringify(data));
	break;
	}
});

// This channel is for client to server messages to intiate a call
socket.on('wallboardv1', function (data) {
	switch(data.type)
	{
		default:
			console.log("unknown message on server channel "+JSON.stringify(data));
		break;
	}
});


function insertrow(id, type, datachannel, priority, status, timestamp, url, position){
  var table = document.getElementById("queue");
  var row = table.insertRow(-1);
  row.id = id;
  var cell1 = row.insertCell(0);
  var cell2 = row.insertCell(1);
  var cell3 = row.insertCell(2);
  var cell4 = row.insertCell(3);
  var cell5 = row.insertCell(4);
  var cell6 = row.insertCell(5);

  // Add some text to the new cells:
  cell1.innerHTML = type;
  cell2.innerHTML = priority;
  cell3.innerHTML = status;
  cell4.innerHTML = timestamp;
  cell5.innerHTML = url;
  cell6.interHTML = "";
}

function updaterow(id, status, position, connectedto, answertype){
  var row = document.getElementById(id);
  row.cells[2].innerHTML = status;
  if(connectedto != undefined) row.cells[5].innerHTML = connectedto;
  if(answertype != undefined) row.cells[0].innerHTML = answertype;
}

function cancelrow(id){
  var row = document.getElementById(id);
  row.parentNode.removeChild(row);
}


// messages sent over the client to server link

function videochat() {
	var msg = {
		type: "videochat",
		channel: datalisten
  };
  socket.emit('clientv1',msg);
	// we want to set the cookie status so extra browser windows know
	document.cookie = "status=videochat";
}



// Utilities
function $(id){ return document.getElementById(id); }
function log(msg){ $("log").innerHTML+="<br>"+msg; }
//function onkey(event){ if(event.keyCode==13){ send(); } }
</script>

</head>
<body>
<div id="status"><font color="red">Connecting ...</font></div>
<table id="queue" style="width:40%">
  <tr>
    <th>Type</th>
    <th>Priority</th>
    <th>Status</th>
    <th>Timestamp</th>
    <th>URL</th>
    <th>Connected to</th>
  </tr>
</table>

</body>
</html>
